# -*- coding: utf-8 -*-

# Copyright (c) 2002, 2003 Detlev Offenbach <detlev@die-offenbachs.de>
#

"""
Module defing general purpose icons and the IconProvider class.
"""

from qt import QPixmap, QFileDialog, QFileIconProvider

from FileIcons import *

# Convert all the XPM icons to QPixmaps.

IconOpenXPM = [
    "20 18 5 1",
    ". c None",
    "# c #000000",
    "c c #c0c000",
    "a c #ffff00",
    "b c #ffffc0",
    "....................",
    "........####........",
    ".......##.####.#....",
    "......#.....####....",
    ".............###....",
    "............####....",
    "...####.............",
    "..#abba#######......",
    "..#bbbbaaaaaaa#.....",
    "..#bb#############..",
    "..#ba#bbbbbbbbbbb#..",
    "..#b#baaaacacacc#...",
    "..#a#baaacacaccc#...",
    "..##baaacacaccc#....",
    "..##baacacacccc#....",
    "..#baacacacccc#.....",
    "..#############.....",
    "...................."
]

IconOpen = QPixmap(IconOpenXPM)


IconCloseXPM = [
    "20 18 3 1",
    ". c None",
    "# c #000000",
    "a c #ffffff",
    "....................",
    ".......#####........",
    ".....#########......",
    "....###########.....",
    "...##aa#####aa##....",
    "...##aaa###aaa##....",
    "..####aaa#aaa####...",
    "..#####aaaaa#####...",
    "..######aaa######...",
    "..#####aaaaa#####...",
    "..####aaa#aaa####...",
    "...##aaa###aaa##....",
    "...##aa#####aa##....",
    "....###########.....",
    ".....#########......",
    ".......#####........",
    "....................",
    "...................."
]

IconClose = QPixmap(IconCloseXPM)


IconExitXPM = [
    "20 18 4 1",
    ". c None",
    "# c #000000",
    "b c #303030",
    "a c #757575",
    ".........##.........",
    ".........##.........",
    ".....#...##...#.....",
    "....###..##..###....",
    "...a##a..##..a##a...",
    "...##b...##...b##...",
    "..a##a...##...a##a..",
    "..###....##....###..",
    "..##a....##....a##..",
    "..##a....##....a##..",
    "..###....##....###..",
    "..a##a........a##a..",
    "...##b........b##...",
    "...a##ba....ab##a...",
    "....a####aa####a....",
    ".....a########a.....",
    ".......a####a.......",
    "...................."
]

IconExit = QPixmap(IconExitXPM)


IconWhatsThisXPM = [
    '16 16 3 1',
    '   c None',
    'o  c #000000',
    'a  c #000080',
    'o        aaaaa  ',
    'oo      aaa aaa ',
    'ooo    aaa   aaa',
    'oooo   aa     aa',
    'ooooo  aa     aa',
    'oooooo  a    aaa',
    'ooooooo     aaa ',
    'oooooooo   aaa  ',
    'ooooooooo aaa   ',
    'ooooo     aaa   ',
    'oo ooo          ',
    'o  ooo    aaa   ',
    '    ooo   aaa   ',
    '    ooo         ',
    '     ooo        ',
    '     ooo        '
]

IconWhatsThis = QPixmap(IconWhatsThisXPM)


IconConfigureXPM = [
    "20 18 9 1",
    ". c None",
    "# c #000000",
    "g c #303030",
    "b c #585858",
    "a c #808080",
    "d c #a0a0a0",
    "e c #c3c3c3",
    "c c #dcdcdc",
    "f c #ffffff",
    "....................",
    ".....######.........",
    ".....#abccd##.......",
    "......#ebbced#......",
    "..###..##ebcd#......",
    "..#fd##..#bccd#.....",
    "..#fccc#bbcccd#.....",
    "..#bffccccccccd##...",
    "..gfbbffcccccccdd#..",
    "..#ecfbbbbdffccccd..",
    "...##eceedbbbffccc..",
    ".....###deeedbbffc..",
    "........####ccdbbf..",
    "............##ccdb..",
    "..............##cc..",
    "................##..",
    "....................",
    "...................."
]

IconConfigure = QPixmap(IconConfigureXPM)


IconConfigureShortcutsXPM = [
    "20 18 13 1",
    ". c None",
    "# c #000000",
    "k c #232323",
    "g c #303030",
    "j c #3a3a3a",
    "b c #585858",
    "i c #595959",
    "h c #777777",
    "a c #808080",
    "d c #a0a0a0",
    "e c #c3c3c3",
    "c c #dcdcdc",
    "f c #ffffff",
    "....................",
    ".....######.........",
    ".....#abccd##.......",
    "......#ebbced#......",
    "..###..##ebcd#......",
    "..#fd##..#bccd#.....",
    "..#fccc#bbcccd#.....",
    "..#bffccccccccd##...",
    "..gfbbffcccccccdd#..",
    "..#ecfbbbbdffccccd..",
    "..hiiiiiiiiiiiiiij..",
    "..ifccccccccccccdk..",
    "..icfdfdfdfdfdfddk..",
    "..icdidididididfdk..",
    "..icffdfdfdfdfffdk..",
    "..icddididididddik..",
    "..jkkkkkkkkkkkkkk#..",
    "...................."
]

IconConfigureShortcuts = QPixmap(IconConfigureShortcutsXPM)


IconZoomInXPM = [
    "20 18 12 1",
    ". c None",
    "# c #000000",
    "i c #004040",
    "d c #008080",
    "b c #00c0c0",
    "h c #00ffff",
    "g c #303030",
    "a c #585858",
    "e c #808080",
    "c c #c0ffff",
    "j c #c3c3c3",
    "f c #ffffff",
    "....................",
    "......###.......a...",
    "....##bcb##.........",
    "...#dcccccd#...ee...",
    "...#ccfifcc#..eaaa..",
    "..#bcfficccb#.aaag..",
    "..#cciiiiicc#..gg...",
    "..#bcfcicccb#.......",
    "...#ccciccc#........",
    "...#dcccccd#h.......",
    "....##bcb##b##......",
    "......###.i#aj#.....",
    "....a......#gaj#....",
    "......a.....#gaj#...",
    "...ee........#gaj#..",
    "..eaaa.a......#ga#..",
    "..aaag.........##...",
    "...................."
]

IconZoomIn = QPixmap(IconZoomInXPM)


IconZoomOutXPM = [
    "20 18 12 1",
    ". c None",
    "# c #000000",
    "i c #004040",
    "d c #008080",
    "b c #00c0c0",
    "h c #00ffff",
    "g c #303030",
    "a c #585858",
    "e c #808080",
    "c c #c0ffff",
    "j c #c3c3c3",
    "f c #ffffff",
    "....................",
    "......###.......a...",
    "....##bcb##.........",
    "...#dcccccd#...ee...",
    "...#ccfffcc#..eaaa..",
    "..#bcfffcccb#.aaag..",
    "..#cciiiiicc#..gg...",
    "..#bcfcccccb#.......",
    "...#ccccccc#........",
    "...#dcccccd#h.......",
    "....##bcb##b##......",
    "......###.i#aj#.....",
    "....a......#gaj#....",
    "......a.....#gaj#...",
    "...ee........#gaj#..",
    "..eaaa.a......#ga#..",
    "..aaag.........##...",
    "...................."
]

IconZoomOut = QPixmap(IconZoomOutXPM)


IconZoomToXPM = [
    "20 18 12 1",
    ". c None",
    "# c #000000",
    "g c #004040",
    "d c #008080",
    "b c #00c0c0",
    "i c #00ffff",
    "h c #303030",
    "a c #585858",
    "e c #808080",
    "c c #c0ffff",
    "j c #c3c3c3",
    "f c #ffffff",
    "....................",
    "......###.......a...",
    "....##bcb##.........",
    "...#dcccccd#...ee...",
    "...#ccffgcc#..eaaa..",
    "..#bcfffggcb#.aaah..",
    "..#cgggggggc#..hh...",
    "..#bcfccggcb#.......",
    "...#ccccgcc#........",
    "...#dcccccd#i.......",
    "....##bcb##b##......",
    "......###.g#aj#.....",
    "....a......#haj#....",
    "......a.....#haj#...",
    "...ee........#haj#..",
    "..eaaa.a......#ha#..",
    "..aaah.........##...",
    "...................."
]

IconZoomTo = QPixmap(IconZoomToXPM)


IconSplitHorizontalXPM = [
    "20 18 4 1",
    ". c None",
    "# c #808080",
    "a c #dedede",
    "b c #ffffff",
    "....................",
    "..###############...",
    "..#aaaaaa#aaaaaa#a..",
    "..#abbbbb#abbbbb#a..",
    "..#abbbbb#abbbbb#a..",
    "..#abbbbb#abbbbb#a..",
    "..#abbbbb#abbbbb#a..",
    "..#abbbbb#abbbbb#a..",
    "..#abbbbb#abbbbb#a..",
    "..#abbbbb#abbbbb#a..",
    "..#abbbbb#abbbbb#a..",
    "..#abbbbb#abbbbb#a..",
    "..#abbbbb#abbbbb#a..",
    "..#abbbbb#abbbbb#a..",
    "..#abbbbb#abbbbb#a..",
    "..###############a..",
    "...aaaaaaaaaaaaaaa..",
    "...................."
]

IconSplitHorizontal = QPixmap(IconSplitHorizontalXPM)


IconSplitVerticalXPM = [
    "20 18 4 1",
    ". c None",
    "# c #808080",
    "a c #dedede",
    "b c #ffffff",
    "....................",
    "..###############...",
    "..#aaaaaaaaaaaaa#a..",
    "..#abbbbbbbbbbbb#a..",
    "..#abbbbbbbbbbbb#a..",
    "..#abbbbbbbbbbbb#a..",
    "..#abbbbbbbbbbbb#a..",
    "..#abbbbbbbbbbbb#a..",
    "..###############a..",
    "..#aaaaaaaaaaaaa#a..",
    "..#abbbbbbbbbbbb#a..",
    "..#abbbbbbbbbbbb#a..",
    "..#abbbbbbbbbbbb#a..",
    "..#abbbbbbbbbbbb#a..",
    "..#abbbbbbbbbbbb#a..",
    "..###############a..",
    "...aaaaaaaaaaaaaaa..",
    "...................."
]

IconSplitVertical = QPixmap(IconSplitVerticalXPM)


IconBookmarkToggleXPM = [
    "20 18 12 1",
    ". c None",
    "# c #000000",
    "d c #004040",
    "c c #008080",
    "j c #00c0c0",
    "h c #00ffff",
    "e c #303030",
    "i c #585858",
    "b c #800080",
    "a c #c000c0",
    "g c #c0ffff",
    "f c #ffffff",
    "....................",
    ".############.......",
    "..#aaaabababb##.....",
    "...#aababababab#....",
    "....#aababbbbbbb#...",
    "...#aababababbbb#...",
    "..#bababbbbbbbbb#...",
    ".############bbb#...",
    "..........#cccccd...",
    ".........#ecfgghd...",
    "........#iicghhjd...",
    ".......#iiicghhjd...",
    ".......eecccghhjddd.",
    "..........dgghhjjd..",
    "...........dhhhjd...",
    "............djjd....",
    ".............dd.....",
    "...................."
]

IconBookmarkToggle = QPixmap(IconBookmarkToggleXPM)


IconBookmarkPreviousXPM = [
    "20 18 12 1",
    ". c None",
    "# c #000000",
    "e c #004040",
    "c c #008080",
    "i c #00c0c0",
    "h c #00ffff",
    "d c #303030",
    "f c #585858",
    "b c #800080",
    "a c #c000c0",
    "g c #c0ffff",
    "j c #ffffff",
    "....................",
    ".############.......",
    "..#aaaabababb##.....",
    "...#aababababab#....",
    "....#aababbbbbbb#...",
    "...#aababababbbb#...",
    "..#bababbbbbbbbb#...",
    ".############bcb#...",
    "..........#ddceb#...",
    ".........#dfcgeeeee.",
    "........#ffcgghhiie.",
    ".......#ffcjhhhhhie.",
    ".......dddcghhhhhie.",
    "...........eiiiiiie.",
    "............eieeeee.",
    ".............ee.....",
    "..............e.....",
    "...................."
]

IconBookmarkPrevious = QPixmap(IconBookmarkPreviousXPM)


IconBookmarkNextXPM = [
    "20 18 12 1",
    ". c None",
    "# c #000000",
    "e c #004040",
    "c c #008080",
    "f c #00c0c0",
    "j c #00ffff",
    "d c #303030",
    "g c #585858",
    "b c #800080",
    "a c #c000c0",
    "i c #c0ffff",
    "h c #ffffff",
    "....................",
    ".############.......",
    "..#aaaabababb##.....",
    "...#aababababab#....",
    "....#aababbbbbbb#...",
    "...#aababababbbb#...",
    "..#bababbbbbbbbb#...",
    ".############bcb#...",
    "..........#dd#ce#...",
    ".........#cccccfe...",
    "........#gchiiijfe..",
    ".......#ggcijjjjjfe.",
    ".......dddcijjjjjfe.",
    "..........cifffffe..",
    "..........eeeeefe...",
    "..............ee....",
    "..............e.....",
    "...................."
]

IconBookmarkNext = QPixmap(IconBookmarkNextXPM)


IconEricXPM = [
    "32 32 31 1",
    "k c #0e0d0c",
    "j c #24201e",
    "i c #46352d",
    "n c #55433d",
    "e c #5e5441",
    "u c #754a35",
    "r c #775b3e",
    "h c #7f6a4a",
    "m c #887b79",
    "C c #897a54",
    "o c #9a5b40",
    "f c #9c9496",
    "B c #9e9069",
    "q c #a26d47",
    "A c #a6835d",
    "g c #aea18a",
    "x c #b3704d",
    "l c #b9b2ad",
    "t c #bb7e57",
    "v c #bc9076",
    "w c #c99068",
    "y c #c9a182",
    "d c #ccbfb4",
    "z c #d7b49b",
    "a c #d7d0cc",
    "s c #dea284",
    "b c #e0dedd",
    "c c #ece8e8",
    "# c #f1f0f0",
    "p c #ff0000",
    ". c #ffffff",
    "................##.abbc.........",
    "...............#aadeeefa........",
    "...............cghijjjifa#......",
    "..............cgejkkkjkjel#.....",
    "............#amnkkkkkkkjjf#.....",
    "...........#leijkkkjiojkimb.....",
    "....p...p..aejjkkkjjjqenonf.....",
    "...p.....p.lijerjkjjjqsstol#....",
    "...p.....p.anmtuiiuumvwxoimb....",
    "....p...p.#mnyouiowooooouuq.....",
    ".....ppp..#dlfqooqttxouoouz.....",
    "...........#hqwwooxxtxooxtb.....",
    "...........clmwtxooxwtxuxw#.....",
    "...ppppppp...dsottooxtoooz......",
    "............#sstxxvvqtxtqw......",
    "............aswoqhtywxoqtA......",
    "....pp...p..zwtd#qAtArABqy......",
    "...p..p.p...cc#flCBACCed........",
    "...p..pp....#cdegggBCBhB........",
    "...ppppppp..#lmCgBBBBBAA........",
    ".............gnBBBBCCChC........",
    "............cleChhCCChChb.......",
    "...p.....p..bfeBheeheeerB.......",
    "...p..p..p..bffBBCeneenCC.......",
    "...p..p..p...#afBBCejinhB.......",
    "...ppppppp..##bCeheCkierd.......",
    ".............#lBCCejjieel.......",
    "...........##blgCCejieuhqz#.....",
    "............#blggBAeierhyvy.....",
    "...........###lggAvAfmrAAtv#....",
    ".............#lgvtwtdbaazzc.....",
    "..............#dzyydc#.#.#......"
]

IconEric = QPixmap(IconEricXPM)


IconEmptyXPM = [
    "1 1 1 1",
    ". c None",
    "."
]

IconEmpty = QPixmap(IconEmptyXPM)


# Set the icon provider.

class IconProvider(QFileIconProvider):
    """
    Class providing icons to QFileDialog.

    The icons provided are for Python (*.py), Qt-Designer (*.ui),
    QT-Linguist (*.ts), Qt project (*.pro) and eric3 project (*.e3p) files.
    """
    def __init__(self):
        QFileIconProvider.__init__(self)

    def pixmap(self,finfo):
        if str(finfo.extension()) in ['py', 'pyx']:
            pm = IconFilePython
        elif str(finfo.extension()) == 'ui':
            pm = IconFileDesigner
        elif str(finfo.extension()) == 'ts':
            pm = IconFileLinguist
        elif str(finfo.extension()) in ['e3p', 'pro']:
            pm = IconFileProject
        elif str(finfo.extension()) == 'idl':
            pm = IconFileIDL
        else:
            pm = None

        return pm


IconProviderInstance = IconProvider()
QFileDialog.setIconProvider(IconProviderInstance)
